---
Title: Docker
Author: Tamas
Topics:
  - short description
  - software interoperability
  - archiving of software
status: unedited
---

Due to the huge variety of operating systems, languages and frameworks, the
number of possible system configurations has grown rapidly in the past decades.
Operating-system-level virtualisation is one of the most successful techniques
to tackle this problem and allows the conservation of environments, making them
interoperable and reproducible in an almost system agnostic way. KM3NeT utilises
Docker (https://www.docker.com) for this task, which is the most popular
containerisation solution with high interoperability. Docker containers run with
negligible performance overhead and create an isolated environment in a fully
reproducible manner, regardless of the host system as long as Docker itself is
supported (Linux, macOS and Windows).
These containers are used in the GitLab CI to run test suites in many different
configurations. Python based projects for example can easily be tested under
different Python versions.
